﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml.Linq;

namespace GPD
{
    public partial class WebForm2 : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (SessionHandler.IsLoggedIn == false)
                Response.Redirect("Login.aspx");
            else
            {
                user_name.Text = DatabaseHandler.getFirstName(SessionHandler.Email);
                GetInformation();
            }
        }

        protected void PersonalEdit_Click(object sender, EventArgs e)
        {
            if (edit_first_name.Visible == false)
            {
                first_name.Visible = false;
                last_name.Visible = false;
                sex.Visible = false;
                nationality.Visible = false;

                // Kirjoitetaan tiedot muokkauslaatikoihin
                edit_first_name.Text = first_name.Text;
                edit_last_name.Text = last_name.Text;
                if(sex.Text != "")
                    edit_sex.Text = sex.Text;
                if(nationality.Text != "")
                    edit_nationality.Text = nationality.Text;

                save_personal.Visible = true;
                edit_first_name.Visible = true;
                edit_last_name.Visible = true;
                edit_sex.Visible = true;
                edit_nationality.Visible = true;

                edit_personal.Text = "Cancel";
            }
            else
            {
                first_name.Visible = true;
                last_name.Visible = true;
                sex.Visible = true;
                nationality.Visible = true;

                edit_first_name.Visible = false;
                edit_last_name.Visible = false;
                save_personal.Visible = false;
                edit_sex.Visible = false;
                edit_nationality.Visible = false;

                edit_personal.Text = "Edit";
            }
        }

        protected void SavePersonal_Click(object sender, EventArgs e)
        {
            // Tähän tallennukset tietokantaan

            DatabaseHandler.editFirstName(SessionHandler.Email, edit_first_name.Text);
            DatabaseHandler.editLastName(SessionHandler.Email, edit_last_name.Text);
            DatabaseHandler.editNationality(SessionHandler.Email, edit_nationality.Text);
            DatabaseHandler.editSex(SessionHandler.Email, edit_sex.Text);

            GetInformation();
            PersonalEdit_Click(this, e);
        }

        private void GetInformation()
        {
            // Haetaan tiedot kenttiin
            gpd_rank.Text = DatabaseHandler.getRank(SessionHandler.Email).ToString();
            gpd_index.Text = DatabaseHandler.getPoints(SessionHandler.Email).ToString();

            first_name.Text = DatabaseHandler.getFirstName(SessionHandler.Email);
            last_name.Text = DatabaseHandler.getLastName(SessionHandler.Email);
            nationality.Text = DatabaseHandler.getNationality(SessionHandler.Email);
            sex.Text = DatabaseHandler.getSex(SessionHandler.Email);

            setVehicle_ temp = DatabaseHandler.getVehicleInfo(SessionHandler.Email);
            vehicle_fuel_type.Text = temp.fueltype;
            vehicle_fuelconsumption.Text = temp.consumption.ToString();
            vehicle_manufacturer.Text = temp.manufacturer;
            vehicle_model.Text = temp.model;
            vehicle_year.Text = temp.year.ToString();
        }

        protected void VehicleEdit_Click(object sender, EventArgs e)
        {
            if (edit_fuel_type.Visible == false)
            {
                vehicle_fuel_type.Visible = false;
                vehicle_fuelconsumption.Visible = false;
                vehicle_manufacturer.Visible = false;
                vehicle_model.Visible = false;
                vehicle_year.Visible = false;

                edit_fuel_type.Text = vehicle_fuel_type.Text;
                edit_vehicle_fuelconsumption.Text = vehicle_fuelconsumption.Text;
                edit_vehicle_manufacturer.Text = vehicle_manufacturer.Text;
                edit_vehicle_model.Text = vehicle_model.Text;

                for (int year = DateTime.Now.Year; year >= 1900; --year)
                {
                    edit_vehicle_year.Items.Add(new ListItem(year.ToString(), year.ToString()));
                }

                edit_vehicle_year.Text = vehicle_year.Text;

                edit_fuel_type.Visible = true;
                edit_vehicle_fuelconsumption.Visible = true;
                edit_vehicle_manufacturer.Visible = true;
                edit_vehicle_model.Visible = true;
                edit_vehicle_year.Visible = true;

                save_vehicle.Visible = true;

                edit_vehicle.Text = "Cancel";

            }
            else
            {
                vehicle_fuel_type.Visible = true;
                vehicle_fuelconsumption.Visible = true;
                vehicle_manufacturer.Visible = true;
                vehicle_model.Visible = true;
                vehicle_year.Visible = true;

                edit_fuel_type.Visible = false;
                edit_vehicle_fuelconsumption.Visible = false;
                edit_vehicle_manufacturer.Visible = false;
                edit_vehicle_model.Visible = false;
                edit_vehicle_year.Visible = false;

                save_vehicle.Visible = false;

                edit_vehicle.Text = "Edit";
            }
        }

        protected void SaveVehicle_Click(object sender, EventArgs e)
        {
            DatabaseHandler.editVehicleInfo(SessionHandler.Email, edit_vehicle_manufacturer.Text, edit_vehicle_model.Text, int.Parse(edit_vehicle_year.Text), float.Parse(edit_vehicle_fuelconsumption.Text), edit_fuel_type.Text);

            VehicleEdit_Click(this, e);

            GetInformation();
        }

        protected void edit_vehicle_year_SelectedIndexChanged(object sender, EventArgs e)
        {

        }
    }
}
